#This is a modfication of the PAP makefile found here:
#https://gitlab.fel.cvut.cz/b4m35pap/stud-support/-/tree/master/riscv/riscv-asm-template?ref_type=heads

# target tool-chain selection
# name consists of architecture vendor operating system and binary format
ARCH=riscv64-unknown-elf
#ARCH=riscv64-linux-gnu
SHELL := /bin/bash
# when C code with main is used, enable next line
SOURCES += crt0local.S irq_handler.S irq.c

# the name of the target executable file
#TARGET_EXE_BOILERPLATE?=$(shell basename $(CFILE) | cut -d. -f1 | sed "s/ *$$//")  #change_me
TARGET_EXE=irq_handler#$(strip $(TARGET_EXE_BOILERPLATE))

# specify compiler and utilities binaries
CC=$(ARCH)-gcc
CXX=$(ARCH)-g++
AS=$(ARCH)-as
LD=$(ARCH)-ld
OBJCOPY=$(ARCH)-objcopy
OBJDUMP=$(ARCH)-objdump

# specify ABI for parameters passing, architecture, its variant etc.
ARCHFLAGS += -mabi=ilp32
ARCHFLAGS += -march=rv32im
ARCHFLAGS += -fno-lto

# debugging, optimize for size, warnings etc.
CFLAGS  += -ggdb -Ofast -Wall
CXXFLAGS+= -ggdb -Ofast -Wall
AFLAGS  += -ggdb

# linker flags, debugging, no implicit libraries and start files
LDFLAGS += -ggdb
LDFLAGS += -nostartfiles
LDFLAGS += -nostdlib
LDFLAGS += -static

# linker script to map text section and start from address 0x00000200
# on the address 0x00000000 is value pointing to the end of memory
# and on the address 0x00000004 is pointer to start of program
# this information is used in VHDL version of RVAPO implementation
LDFLAGS += -Triscv32-bare.ld

#LDFLAGS += -specs=/opt/musl/riscv64-linux-gnu/lib/musl-gcc.specs

LOADLIBES += -lgcc

CFLAGS  += $(ARCHFLAGS)
CXXFLAGS+= $(ARCHFLAGS)
AFLAGS  += $(ARCHFLAGS)
LDFLAGS += $(ARCHFLAGS)

# generate list of object files from the specified sources
OBJECTS += $(filter %.o,$(SOURCES:%.S=%.o))
OBJECTS += $(filter %.o,$(SOURCES:%.c=%.o))
OBJECTS += $(filter %.o,$(SOURCES:%.cpp=%.o))

# the first target is the default one when make invoked without argument
all : default

# targets which are only wishes and do not generate corresponding files
.PHONY : default clean all run #dep


# generic rules how to compile one file type to another

%.o:%.S
	$(CC) -D__ASSEMBLY__ $(AFLAGS) -c $< -o $@

%.o:%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

%.o:%.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $<

%.s:%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -S $< -o $@

#%.srec:%
#	$(OBJCOPY) -O srec $< $@
%.txt:%
	$(OBJDUMP) -S -D $< > ../../out/instrdump/$@

%.dat:%.bin
	hexdump -v -e '"0x%08x;\n" ' $< > ../../out/rdwrmem/$@

#the generated file is in a different folder and has different extension, thus the required one will never exist, and the rule will always trigger
%.decb:%.bin
	hexdump -v -e '1/1 "%u\n" ' $< > ../../out/hexstr/rvapo_mem_content.txt
#	hexdump -v -e '1/1 "%u\n" ' $< >$@

# --only-section=.text
%.bin:%
	$(OBJCOPY) --strip-debug -O binary $< $@

%.out:%
	$(OBJCOPY) -O ecoff-bigmips $< $@

convertor.out:convertor.c
	gcc $< -o $@

%.vhdl:%.bin convertor.out
	./convertor.out -vhdl $< ../../out/vhdl/$@
	./convertor.out -ice40 $< ../../out/ice40/$@

# compute dependencies of object files on all sources used/included

#dep: depend

#depend: $(SOURCES) $(glob *.h)
#	echo '# autogenerated dependencies' > depend
#ifneq ($(filter %.S,$(SOURCES)),)
#	$(CC)  -D__ASSEMBLY__ $(AFLAGS) -w -E -M $(filter %.S,$(SOURCES)) \
#	  >> depend
#endif
#ifneq ($(filter %.c,$(SOURCES)),)
#	$(CC) $(CFLAGS) $(CPPFLAGS) -w -E -M $(filter %.c,$(SOURCES)) \
#	  >> depend
#endif
#ifneq ($(filter %.cpp,$(SOURCES)),)
#	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -w -E -M $(filter %.cpp,$(SOURCES)) \
#	  >> depend
#endif

# specify default target dependencies
# specifies what is build when make invoked without target specified

#default : $(TARGET_EXE)
#default : $(TARGET_EXE).srec $(TARGET_EXE).dat $(TARGET_EXE).decb
default : $(TARGET_EXE).dat $(TARGET_EXE).decb $(TARGET_EXE).txt
	#rm $(TARGET_EXE)

# specification for executable build

$(TARGET_EXE) : $(OBJECTS)
	$(CC) $(LDFLAGS) $^ $(LOADLIBES) -o $@

# target to clean all compilation products

clean:
	rm -f *.o *.a $(OBJECTS) $(TARGET_EXE) depend \
		$(TARGET_EXE).out $(TARGET_EXE).srec \
		$(TARGET_EXE).dat $(TARGET_EXE).decb

# run code in QtRvSim command-line version

run: $(TARGET_EXE)
	qtrvsim_cli --pipelined \
		--dump-cycles --dump-registers \
		$<

-include depend
